/*
**************************************************************************
This is a modified script.(Information on an original script is the following)
Very thanks to steve johnson!!

Modified:
- 1.fixing Gmax-shutdown(bug?) in some situations.
- 2.support multi-objects selection.
- 3.Message window pops up. (it have same strings as prompt window)

Usage:
- Replace Steve's original script.
or
- Put into "ui\macroscripts" folder, then add Menus or Quads.

2009.11.22
by ponz
http://ponz2009.web.fc2.com


--------Information on an original script--------
Max 4.x script add-ons
Copyright 2000-2001 steve johnson
web: www.chuggnut.demon.co.uk
email: steve@chuggnut.demon.co.uk

Requirements:
- Max 4.x
- Some sort of brain

Title:
- Clear dead UVW's


Useage:
- put this in your quad.  This will clear out all dead UV's in all mapping channels.  Use before applying or reapplying a "Unwrap UV" mod.

Issuses:
- none yet!
**************************************************************************
*/

macroscript cleardeaduvs category:"Chugg's Tools" buttontext:"Clear Dead UVW's"
	(
	on execute do
		(
		if selection.count != 0 then
			(
			local newcount = 0
			local uvvertcount = 0
			local channelcount = 0
			local meshcount = 0
			for i = 1 to selection.count do
				(
				if classof selection[i] == editable_mesh do
					(
					meshcount += 1
					for j = 1 to (meshop.getnummaps selection[i]) do
						(
						if (meshop.getmapsupport selection[i] j) do
							(
							uvvertcount += meshop.getNumMapVerts selection[i] j
							channelcount += 1
							v = meshop.getisomapverts selection[i] j
							for n in v do
								(
								if v[n] do newcount += 1
								)
							)
						)
					meshop.deleteIsoMapVertsAll selection[i]
					)
				)
			if 0 == meshcount do
				(
				messagebox "Select Editable_Meshes!"
				)
			pushprompt ("Cleared out " + newcount as string + "/" + uvvertcount as string + " dead UV's in " + channelcount as string + " maps, in " + meshcount as string + " meshes.")
			messagebox ("Cleared out " + newcount as string + "/" + uvvertcount as string + " dead UV's\nin " + channelcount as string + " maps, in " + meshcount as string + " meshes.")
			)
		else
			(
			messagebox "Select objects!"
			)
		)
	)-- end of macro